local E, L, V, P, G = unpack(ElvUI); --Inport: Engine, Locales, PrivateDB, ProfileDB, GlobalDB

local CURRENT_PAGE = 0
local MAX_PAGE = 1

SLASH_TOHR1, SLASH_TOHR2, SLASH_TOHR3 = '/tui', '/tohr', '/tohrui';
function SlashCmdList.TOHR(msg, editbox)
	if msg == 'help' then
		 print('|cffffff00Tohr UI |cffffffffusage:');
		 print('/tui');
		 print('/tui reset');
		 print('/tui install');
		 print('/tui options');
	elseif msg == 'reset' then
		E:ResetUI()
	elseif msg == 'install' then
		E:Install();
	elseif msg == 'options' then
		E:Install();
	else
		E:Install();
	end
end




Tohr_Version = GetAddOnMetadata("ElvUI_TohrUI", "Version");
Tohr_Title = GetAddOnMetadata("ElvUI_TohrUI", "Title");

L["LOGIN_MSG"] = ""..Tohr_Title.." |cffffffffhas been fully loaded. Type |cffFF4500/tui|cffffffff, |cffFF4500/tohr|cffffffff, or |cffFF4500/tohrui |cffffffffto apply any changes. Please Back Up any profiles before applying changes"

local function SetupChat()
	InstallStepComplete.message = L["Chat Set"]
	InstallStepComplete:Show()			
	FCF_ResetChatWindows()
	FCF_SetLocked(ChatFrame1, 1)
	FCF_DockFrame(ChatFrame2)
	FCF_SetLocked(ChatFrame2, 1)	
	FCF_OpenNewWindow(Chat)
	FCF_SetLocked(ChatFrame3, 1)
	ChatFrame3:Show()
			
	for i = 1, NUM_CHAT_WINDOWS do
		local frame = _G[format("ChatFrame%s", i)]
		local chatFrameId = frame:GetID()
		local chatName = FCF_GetChatWindowInfo(chatFrameId)
				
		FCF_SavePositionAndDimensions(frame)
		FCF_StopDragging(frame)
		
		-- set default Elvui font size
		FCF_SetChatWindowFontSize(nil, frame, 12, "OUTLINE")
		
		-- rename windows general because moved to chat #3
		if i == 1 then
			FCF_SetWindowName(frame, GENERAL)
		elseif i == 2 then
			FCF_SetWindowName(frame, GUILD_EVENT_LOG)
		elseif i == 3 then
			FCF_SetWindowName(frame, "Chat")
		end
	end
	
	ChatFrame_RemoveAllMessageGroups(ChatFrame1)
	ChatFrame_AddMessageGroup(ChatFrame1, "SAY")
	ChatFrame_AddMessageGroup(ChatFrame1, "GUILD")
	ChatFrame_AddMessageGroup(ChatFrame1, "OFFICER")
	ChatFrame_AddMessageGroup(ChatFrame1, "GUILD_ACHIEVEMENT")
	ChatFrame_AddMessageGroup(ChatFrame1, "WHISPER")
	ChatFrame_AddMessageGroup(ChatFrame1, "BN_WHISPER")
	ChatFrame_AddMessageGroup(ChatFrame1, "BN_CONVERSATION")
	ChatFrame_AddMessageGroup(ChatFrame1, "BN_INLINE_TOAST_ALERT")
	ChatFrame_AddMessageGroup(ChatFrame1, "PARTY")
	ChatFrame_AddMessageGroup(ChatFrame1, "PARTY_LEADER")
	ChatFrame_AddMessageGroup(ChatFrame1, "RAID")
	ChatFrame_AddMessageGroup(ChatFrame1, "RAID_LEADER")
	ChatFrame_AddMessageGroup(ChatFrame1, "RAID_WARNING")
	ChatFrame_AddMessageGroup(ChatFrame1, "BATTLEGROUND")
	ChatFrame_AddMessageGroup(ChatFrame1, "BATTLEGROUND_LEADER")
	ChatFrame_AddMessageGroup(ChatFrame1, "BG_HORDE")
	ChatFrame_AddMessageGroup(ChatFrame1, "BG_ALLIANCE")
	ChatFrame_AddMessageGroup(ChatFrame1, "BG_NEUTRAL")
	ChatFrame_AddMessageGroup(ChatFrame1, "SYSTEM")
	ChatFrame_AddMessageGroup(ChatFrame1, "AFK")
	ChatFrame_AddMessageGroup(ChatFrame1, "DND")
	ChatFrame_AddMessageGroup(ChatFrame1, "IGNORED")
	ChatFrame_AddMessageGroup(ChatFrame1, "INSTANCE_CHAT")
	ChatFrame_AddMessageGroup(ChatFrame1, "INSTANCE_CHAT_LEADER")
	ChatFrame_AddMessageGroup(ChatFrame1, "CHANNEL")	
	ChatFrame_AddMessageGroup(ChatFrame1, "EMOTE")
	ChatFrame_AddMessageGroup(ChatFrame1, "YELL")
	ChatFrame_AddMessageGroup(ChatFrame1, "ACHIEVEMENT")
	ChatFrame_AddMessageGroup(ChatFrame1, "MONSTER_SAY")
	ChatFrame_AddMessageGroup(ChatFrame1, "MONSTER_EMOTE")
	ChatFrame_AddMessageGroup(ChatFrame1, "MONSTER_YELL")
	ChatFrame_AddMessageGroup(ChatFrame1, "MONSTER_BOSS_EMOTE")
	ChatFrame_AddMessageGroup(ChatFrame1, "MONSTER_WHISPER")
	ChatFrame_AddMessageGroup(ChatFrame1, "BOSS_WHISPER")
	ChatFrame_AddMessageGroup(ChatFrame1, "ERRORS")
	ChatFrame_AddMessageGroup(ChatFrame1, "LOOT")
	ChatFrame_AddMessageGroup(ChatFrame1, "MONEY")
	ChatFrame_AddMessageGroup(ChatFrame1, "SKILL")
	ChatFrame_AddMessageGroup(ChatFrame1, "CURRENCY ")
	ChatFrame_AddMessageGroup(ChatFrame1, "COMBAT_XP_GAIN")
	ChatFrame_RemoveChannel(ChatFrame1, L['LocalDefense'])
	ChatFrame_RemoveChannel(ChatFrame1, L['LookingForGroup'])
	
	ChatFrame_RemoveAllMessageGroups(ChatFrame3)
	ChatFrame_AddMessageGroup(ChatFrame3, "GUILD")
	ChatFrame_AddMessageGroup(ChatFrame3, "GUILD_ACHIEVEMENT")
	ChatFrame_AddMessageGroup(ChatFrame3, "OFFICER")
	ChatFrame_AddMessageGroup(ChatFrame3, "PARTY")
	ChatFrame_AddMessageGroup(ChatFrame3, "PARTY_LEADER")
	ChatFrame_AddMessageGroup(ChatFrame3, "RAID")
	ChatFrame_AddMessageGroup(ChatFrame3, "RAID_LEADER")
	ChatFrame_AddMessageGroup(ChatFrame3, "RAID_WARNING")
	ChatFrame_AddMessageGroup(ChatFrame3, "WHISPER")
	ChatFrame_AddMessageGroup(ChatFrame3, "BN_WHISPER")
	ChatFrame_AddMessageGroup(ChatFrame3, "BN_CONVERSATION")
	ChatFrame_RemoveMessageGroup(ChatFrame3, "BN_INLINE_TOAST_ALERT")
	ChatFrame_RemoveMessageGroup(ChatFrame3, "CHANNEL")	

	-- enable classcolor automatically on login and on each character without doing /configure each time.
	ToggleChatColorNamesByClassGroup(true, "SAY")
	ToggleChatColorNamesByClassGroup(true, "EMOTE")
	ToggleChatColorNamesByClassGroup(true, "YELL")
	ToggleChatColorNamesByClassGroup(true, "GUILD")
	ToggleChatColorNamesByClassGroup(true, "OFFICER")
	ToggleChatColorNamesByClassGroup(true, "GUILD_ACHIEVEMENT")
	ToggleChatColorNamesByClassGroup(true, "ACHIEVEMENT")
	ToggleChatColorNamesByClassGroup(true, "WHISPER")
	ToggleChatColorNamesByClassGroup(true, "PARTY")
	ToggleChatColorNamesByClassGroup(true, "PARTY_LEADER")
	ToggleChatColorNamesByClassGroup(true, "RAID")
	ToggleChatColorNamesByClassGroup(true, "RAID_LEADER")
	ToggleChatColorNamesByClassGroup(true, "RAID_WARNING")
	ToggleChatColorNamesByClassGroup(true, "BATTLEGROUND")
	ToggleChatColorNamesByClassGroup(true, "INSTANCE_CHAT")	
	ToggleChatColorNamesByClassGroup(true, "INSTANCE_CHAT_LEADER")	
	ToggleChatColorNamesByClassGroup(true, "CHANNEL11")
	ToggleChatColorNamesByClassGroup(true, "CHANNEL1")
	ToggleChatColorNamesByClassGroup(true, "CHANNEL2")
	ToggleChatColorNamesByClassGroup(true, "CHANNEL3")
	ToggleChatColorNamesByClassGroup(true, "CHANNEL4")
	ToggleChatColorNamesByClassGroup(true, "CHANNEL5")
	ToggleChatColorNamesByClassGroup(true, "CHANNEL6")
	ToggleChatColorNamesByClassGroup(true, "CHANNEL7")
	ToggleChatColorNamesByClassGroup(true, "CHANNEL8")
	ToggleChatColorNamesByClassGroup(true, "CHANNEL9")
	ToggleChatColorNamesByClassGroup(true, "CHANNEL10")
	ToggleChatColorNamesByClassGroup(true, "CHANNEL11")
	
	--Adjust Chat Colors
	--General
	ChangeChatColor("CHANNEL1", 195/255, 230/255, 232/255)
	--Trade
	ChangeChatColor("CHANNEL2", 232/255, 158/255, 121/255)
	--Local Defense
	ChangeChatColor("CHANNEL3", 232/255, 228/255, 121/255)
end

local function SetupCVars()
	SetCVar("alwaysShowActionBars", 1)
	SetCVar("chatMouseScroll", 1)
	SetCVar("chatStyle", "classic")
	SetCVar('lockActionBars', 1)
	SetCVar("screenshotQuality", 10)
	SetCVar("ShowClassColorInNameplate", 1)
	SetCVar("showTutorials", 0)
	SetCVar('SpamFilter', 0)
	SetCVar("statusTextDisplay", "BOTH")
	SetCVar("threatWarning", 3)
	SetCVar("UberTooltips", 1)
	SetCVar("wholeChatWindowClickable", 0)
	InterfaceOptionsActionBarsPanelPickupActionKeyDropDown:SetValue('CTRL')
	InterfaceOptionsActionBarsPanelPickupActionKeyDropDown:RefreshValue()
	InstallStepComplete.message = L["CVars Set"]
	InstallStepComplete:Show()					
end	

function E:GetColor(r, b, g, a)	
	return { r = r, b = b, g = g, a = a }
end

function E:SetupTheme(theme, noDisplayMsg)
	local classColor = RAID_CLASS_COLORS[E.myclass]
	E.private.theme = theme
	if not E.db.movers then E.db.movers = {}; end
		if theme == "TohrUI" then
		InstallStepComplete.message = L["TohrUI Installed"]
		InstallStepComplete:Show()
	-- Movers
		E.db.movers["ElvUF_FocusCastbarMover"] = "TOPLEFT,ElvUIParent,TOPLEFT,30,-30"
		E.db.movers["ElvUF_PlayerCastbarMover"] = "BOTTOM,ElvUIParent,BOTTOM,0,219"
		E.db.movers["ElvUF_RaidMover"] = "BOTTOMLEFT,ElvUIParent,BOTTOMLEFT,30,393"
		E.db.movers["LeftChatMover"] = "BOTTOMLEFT,ElvUIParent,BOTTOMLEFT,30,30"
		E.db.movers["GMMover"] = "BOTTOMRIGHT,ElvUIParent,BOTTOMRIGHT,-272,30"
		E.db.movers["BuffsMover"] = "TOPRIGHT,ElvUIParent,TOPRIGHT,-200,-31"
		E.db.movers["BossButton"] = "BOTTOMRIGHT,ElvUIParent,BOTTOMRIGHT,-325,293"
		E.db.movers["ElvUF_RaidpetMover"] = "TOPLEFT,ElvUIParent,BOTTOMLEFT,1727,192"
		E.db.movers["ElvUF_AssistMover"] = "TOP,ElvUIParent,TOP,-301,-4"
		E.db.movers["DebuffsMover"] = "TOPRIGHT,ElvUIParent,TOPRIGHT,-200,-128"
		E.db.movers["ElvUF_FocusMover"] = "BOTTOM,ElvUIParent,BOTTOM,127,241"
		E.db.movers["ElvUF_BodyGuardMover"] = "BOTTOMLEFT,ElvUIParent,BOTTOMLEFT,607,407"
		E.db.movers["ClassBarMover"] = "BOTTOM,ElvUIParent,BOTTOM,0,322"
		E.db.movers["MicrobarMover"] = "BOTTOMRIGHT,ElvUIParent,BOTTOMRIGHT,-482,30"
		E.db.movers["ElvUF_PetCastbarMover"] = "TOPLEFT,ElvUIParent,TOPLEFT,30,-30"
		E.db.movers["VehicleSeatMover"] = "BOTTOMRIGHT,ElvUIParent,BOTTOMRIGHT,-30,258"
		E.db.movers["ElvUF_PetMover"] = "BOTTOM,ElvUIParent,BOTTOM,-131,91"
		E.db.movers["TotemBarMover"] = "BOTTOMLEFT,ElvUIParent,BOTTOMLEFT,482,72"
		E.db.movers["ElvUF_TargetMover"] = "BOTTOM,ElvUIParent,BOTTOM,315,405"
		E.db.movers["ElvUF_PlayerMover"] = "BOTTOM,ElvUIParent,BOTTOM,0,241"
		E.db.movers["LossControlMover"] = "TOP,ElvUIParent,TOP,0,-350"
		E.db.movers["ElvUF_Raid40Mover"] = "BOTTOMLEFT,ElvUIParent,BOTTOMLEFT,30,208"
		E.db.movers["MirrorTimer1Mover"] = "TOP,ElvUIParent,TOP,0,-100"
		E.db.movers["CM_MOVER"] = "BOTTOM,ElvUIParent,BOTTOM,0,389"
		E.db.movers["ElvAB_1"] = "BOTTOM,ElvUIParent,BOTTOM,0,59"
		E.db.movers["ElvAB_2"] = "BOTTOM,ElvUIParent,BOTTOM,0,30"
		E.db.movers["TalkingHeadFrameMover"] = "TOP,ElvUIParent,TOP,0,-30"
		E.db.movers["ArenaHeaderMover"] = "TOP,ElvUIParent,TOP,-312,-239"
		E.db.movers["ElvAB_4"] = "TOPLEFT,ElvUIParent,TOPLEFT,30,-30"
		E.db.movers["AltPowerBarMover"] = "TOP,ElvUIParent,TOP,0,-210"
		E.db.movers["ElvAB_3"] = "BOTTOM,ElvUIParent,BOTTOM,0,0"
		E.db.movers["ElvAB_5"] = "BOTTOM,ElvUIParent,BOTTOM,0,270"
		E.db.movers["PlayerPowerBarMover"] = "BOTTOM,ElvUIParent,BOTTOM,0,306"
		E.db.movers["ElvUF_TargetCastbarMover"] = "TOP,ElvUIParent,TOP,0,-450"
		E.db.movers["ObjectiveFrameMover"] = "TOPRIGHT,ElvUIParent,TOPRIGHT,-85,-202"
		E.db.movers["BNETMover"] = "BOTTOM,ElvUIParent,BOTTOM,-303,30"
		E.db.movers["ShiftAB"] = "BOTTOMLEFT,ElvUIParent,BOTTOMLEFT,483,30"
		E.db.movers["PetAB"] = "BOTTOM,ElvUIParent,BOTTOM,44,90"
		E.db.movers["ElvAB_6"] = "TOPLEFT,ElvUIParent,TOPLEFT,30,-30"
		E.db.movers["TooltipMover"] = "BOTTOMRIGHT,ElvUIParent,BOTTOMRIGHT,-480,120"
		E.db.movers["ElvUF_TankMover"] = "TOP,ElvUIParent,TOP,-302,-4"
		E.db.movers["BossHeaderMover"] = "TOPRIGHT,ElvUIParent,TOPRIGHT,-285,-225"
		E.db.movers["WatchFrameMover"] = "TOPRIGHT,ElvUIParent,TOPRIGHT,-143,-206"
		E.db.movers["ElvUF_TargetTargetMover"] = "BOTTOM,ElvUIParent,BOTTOM,187,409"
		E.db.movers["RightChatMover"] = "BOTTOMRIGHT,ElvUIParent,BOTTOMRIGHT,-30,30"
		E.db.movers["ComboBarMover"] = "BOTTOM,ElvUIParent,BOTTOM,0,400"
		E.db.movers["MinimapMover"] = "TOPRIGHT,ElvUIParent,TOPRIGHT,-30,-30"
		E.db.movers["ExperienceBarMover"] = "TOPRIGHT,ElvUIParent,TOPRIGHT,-30,-179"
		E.db.movers["ReputationBarMover"] = "TOPRIGHT,ElvUIParent,TOPRIGHT,-30,-179"
		E.db.movers["ArtifactBarMover"] = "TOPRIGHT,ElvUIParent,TOPRIGHT,-30,-19"
		E.db.movers["HonorBarMover"] = "TOPRIGHT,ElvUIParent,TOPRIGHT,-30,-8"
		E.db.movers["LootFrameMover"] = "TOPLEFT,ElvUIParent,TOPLEFT,161,-50"
		E.db.movers["AlertFrameMover"] = "TOPRIGHT,ElvUIParent,TOPRIGHT,-495,-195"
		E.db.movers["ElvUF_PartyMover"] = "TOPLEFT,ElvUIParent,BOTTOMLEFT,819,160"
	
		E.db.bagsOffsetFixed = true
		E.db.hideTutorial = true
		E.db.bossAuraFiltersConverted = true
	-- General
		E.db.general.loginmessage = true
		E.db.general.normTex = "tFlat"
		E.db.general.glossTex = "tFlat"
		E.db.general.dmgfont = "Roboto-Black"
		E.db.general.namefont = "Roboto-Black"
		E.db.general.autoAcceptInvite = false
		E.db.general.font = "Roboto-Black"
		E.db.general.topPanel = false
		E.db.general.bottomPanel = false
		E.db.general.fontSize = 10
		E.db.general.minimap.size = 146
		E.db.general.minimap.icons.lfgEye.xOffset = 6
		E.db.general.minimap.icons.lfgEye.yOffset = -6
		E.db.general.minimap.icons.classHall.yOffset = 3
		E.db.general.minimap.icons.classHall.xOffset = -3
		E.db.general.minimap.icons.classHall.scale = 0.8
		E.db.general.backdropcolor = { r = 40/255,g = 40/255,b = 40/255 }
		E.db.general.backdropfadecolor = { r = 10/255,g = 10/255,b = 10/255, a = 0.65}
		E.db.general.valuecolor = E:GetColor(classColor.r, classColor.b, classColor.g)
		E.db.general.totems.enable = true
		E.db.general.totems.growthDirection = "VERTICAL"
		E.db.general.totems.sortDirection = "DESCENDING"
		E.db.general.vendorGrays = true
		E.db.general.autoRepair = "GUILD"
		E.db.general.autoRoll = true
		E.db.general.objectiveFrameHeignt = 540
		E.db.general.afk = false
	--Unit Frames
		E.db.unitframe.statusbar = "tFlat"
		E.db.unitframe.font = "Semplice C"
		E.db.unitframe.fontSize = 8
		E.db.unitframe.fontOutline = "MONOCHROMEOUTLINE"
		E.db.unitframe.debuffHighlighting = false
		E.db.unitframe.smoothbars = true
		E.db.unitframe.smartRaidFilter = false
		E.db.unitframe.OORAlpha = 0.55
	--Colors
		E.db.unitframe.colors.healthclass = true
		E.db.unitframe.colors.powerclass = false
		E.db.unitframe.colors.colorhealthbyvalue = false
		E.db.unitframe.colors.transparentHealth = false
		E.db.unitframe.colors.classbackdrop = false
		E.db.unitframe.colors.health = { r = 0/255, g = 0/255, b = 0/255 }
		E.db.unitframe.colors.health_backdrop = { r = 34/255,g = 34/255,b = 34/255 }
		E.db.unitframe.colors.tapped = { r = 231/255, g = 241/255, b = 255/255 }
		E.db.unitframe.colors.disconnected = { r = 70/255, g = 70/255, b = 70/255 }
		E.db.unitframe.colors.power.MANA = { r = 79/255,g = 115/255,b = 161/255 }
		E.db.unitframe.colors.power.RAGE = { r = 199/255,g = 64/255,b = 64/255 }
		E.db.unitframe.colors.power.FOCUS = { r = 181/255,g = 110/255,b = 69/255 }
		E.db.unitframe.colors.power.ENERGY = { r = 255/255,g = 234/255,b = 0/255 }
		E.db.unitframe.colors.power.RUNIC_POWER = { r = 0/255,g = 209/255,b = 255/255 }
		E.db.unitframe.colors.reaction.BAD = { r = 199/225, g = 64/225, b = 64/225 }
		E.db.unitframe.colors.reaction.NEUTRAL = { r = 218/255, g = 197/255, b = 92/255 }
		E.db.unitframe.colors.reaction.GOOD = { r = 75/255, g = 175/255, b = 76/255 }
		E.db.unitframe.colors.castColor = { r = 135/255, g = 135/255, b = 135/255 }
		E.db.unitframe.colors.castNoInterrupt = { r = 239/255, g = 31/255, b = 44/255 }
		
		E.db.unitframe.colors.castClassColor = false
		E.db.unitframe.colors.transparentCastbar = false
		E.db.unitframe.colors.customhealthbackdrop = true
		E.db.unitframe.colors.colorhealthbyvalue = false
		E.db.unitframe.colors.transparentAurabars = true
	--Player
		E.db.unitframe.units.player.customTexts = {}
		E.db.unitframe.units.player.combatIcon = false
		E.db.unitframe.units.player.restIcon = false
		E.db.unitframe.units.player.raidIcon = false
		E.db.unitframe.units.player.width = 203
		E.db.unitframe.units.player.height = 30
		E.db.unitframe.units.player.healPrediction = false
		E.db.unitframe.units.player.threatStyle = "NONE"
		E.db.unitframe.units.player.health.text_format = "[health:deficit]"
		E.db.unitframe.units.player.health.xOffset = 1
		E.db.unitframe.units.player.health.yOffset = -2
		E.db.unitframe.units.player.health.position = "TOPRIGHT"
		E.db.unitframe.units.player.name.text_format = ""
		E.db.unitframe.units.player.name.position = "BOTTOMLEFT"
		E.db.unitframe.units.player.name.yOffset = 1
		E.db.unitframe.units.player.power.text_format = "[power:current]"
		E.db.unitframe.units.player.power.position = "CENTER"
		E.db.unitframe.units.player.power.height = 15
		E.db.unitframe.units.player.power.yOffset = 0
		E.db.unitframe.units.player.power.xOffset = 0
		E.db.unitframe.units.player.power.attachTextToPower = true
		E.db.unitframe.units.player.power.attachTextTo = "Power"
		E.db.unitframe.units.player.power.detachFromFrame = true
		E.db.unitframe.units.player.power.detachedWidth = 203
		E.db.unitframe.units.player.power.width = "Filled"
		E.db.unitframe.units.player.pvp.text_format = ""
		E.db.unitframe.units.player.buffs.enable = false
		E.db.unitframe.units.player.buffs.yOffset = -64
		E.db.unitframe.units.player.buffs.attachTo = "FRAME"
		E.db.unitframe.units.player.debuffs.enable = true
		E.db.unitframe.units.player.debuffs.sizeOverride = 30
		E.db.unitframe.units.player.debuffs.xOffset = -2
		E.db.unitframe.units.player.debuffs.yOffset = 0
		E.db.unitframe.units.player.debuffs.fontSize = 8
		E.db.unitframe.units.player.debuffs.attachTo = "Frame"
		E.db.unitframe.units.player.debuffs.anchorPoint = "LEFT"
		E.db.unitframe.units.player.debuffs.perrow = 5
		E.db.unitframe.units.player.debuffs.numrows = 2
		E.db.unitframe.units.player.debuffs.useFilter = "Blacklist"
		E.db.unitframe.units.player.debuffs.spacing = 2
		E.db.unitframe.units.player.castbar.enable = true
		E.db.unitframe.units.player.castbar.width = 203
		E.db.unitframe.units.player.castbar.height = 20
		E.db.unitframe.units.player.castbar.icon = false
		E.db.unitframe.units.player.castbar.latency = false
		E.db.unitframe.units.player.castbar.format = "REMAINING"
		E.db.unitframe.units.player.castbar.ticks = true
		E.db.unitframe.units.player.castbar.spark = false
		E.db.unitframe.units.player.classbar.detachFromFrame = true
		E.db.unitframe.units.player.classbar.fill = "Filled"
		E.db.unitframe.units.player.classbar.detachedWidth = 203
		E.db.unitframe.units.player.classbar.height = 15
		E.db.unitframe.units.player.classbar.autoHide = true
		if E.myclass == "DEATHKNIGHT" and IsAddOnLoaded("CompactRunes") or IsAddOnLoaded("mRunes") or IsAddOnLoaded("tRunes") then
			E.db.unitframe.units.player.classbar.enable = false
		else
			E.db.unitframe.units.player.classbar.enable = true
		end
		E.db.unitframe.units.player.aurabar.enable = false
		E.db.unitframe.units.player.aurabar.attachTo = "FRAME"
		E.db.unitframe.units.player.aurabar.height = 22
		E.db.unitframe.units.player.aurabar.anchorPoint = "BELOW"
		E.db.unitframe.units.player.stagger.enable = false
		E.db.unitframe.units.player.orientation = "MIDDLE"
	--Target
		E.db.unitframe.units.target.rangeCheck = true
		E.db.unitframe.units.target.width = 203
		E.db.unitframe.units.target.height = 42
		E.db.unitframe.units.target.healPrediction = false
		E.db.unitframe.units.target.threatStyle = "NONE"
		E.db.unitframe.units.target.health.text_format = "[health:current] || [health:percent]"
		E.db.unitframe.units.target.health.position = "TOPLEFT"
		E.db.unitframe.units.target.health.xOffset = 0
		E.db.unitframe.units.target.health.yOffset = -2
		E.db.unitframe.units.target.power.enable = true
		E.db.unitframe.units.target.power.height = 8
		E.db.unitframe.units.target.power.width = "inset"
		E.db.unitframe.units.target.power.attachTextToPower = false
		E.db.unitframe.units.target.power.detachedWidth = 200
		E.db.unitframe.units.target.power.detachFromFrame = false
		E.db.unitframe.units.target.power.text_format = ""
		E.db.unitframe.units.target.power.yOffset = 0
		E.db.unitframe.units.target.power.hideonnpc = false
		E.db.unitframe.units.target.power.position = "BOTTOMLEFT"
		E.db.unitframe.units.target.name.position = "TOPRIGHT"
		E.db.unitframe.units.target.name.text_format = "[name:abbrev]"
		E.db.unitframe.units.target.name.xOffset = 1
		E.db.unitframe.units.target.name.yOffset = -2
		E.db.unitframe.units.target.buffs.enable = true
		E.db.unitframe.units.target.buffs.anchorPoint = "RIGHT"
		E.db.unitframe.units.target.buffs.fontSize = 8
		E.db.unitframe.units.target.buffs.xOffset = 1
		E.db.unitframe.units.target.buffs.yOffset = 0
		E.db.unitframe.units.target.buffs.perrow = 4
		E.db.unitframe.units.target.buffs.sizeOverride = 30
		E.db.unitframe.units.target.debuffs.enable = true
		E.db.unitframe.units.target.debuffs.yOffset = -1
		E.db.unitframe.units.target.debuffs.attachTo = "FRAME"
		E.db.unitframe.units.target.debuffs.anchorPoint = "BOTTOMLEFT"
		E.db.unitframe.units.target.debuffs.fontSize = 8
		E.db.unitframe.units.target.debuffs.xOffset = 0
		E.db.unitframe.units.target.debuffs.perrow = 4
		E.db.unitframe.units.target.debuffs.sizeOverride = 30
		E.db.unitframe.units.target.castbar.enable = true
		E.db.unitframe.units.target.castbar.width = 350
		E.db.unitframe.units.target.castbar.height = 25
		E.db.unitframe.units.target.castbar.icon = true
		E.db.unitframe.units.target.castbar.format = "CURRENTMAX"
		E.db.unitframe.units.target.castbar.spark = false
		E.db.unitframe.units.target.castbar.latency = false
		E.db.unitframe.units.target.aurabar.enable = false
		E.db.unitframe.units.target.aurabar.height = 22
		E.db.unitframe.units.target.aurabar.anchorPoint = "BELOW"
		E.db.unitframe.units.target.aurabar.maxDuration = 120
		E.db.unitframe.units.target.aurabar.attachTo = "FRAME"
		E.db.unitframe.units.target.customTexts = {}
	--ToT
		E.db.unitframe.units.targettarget.enable = true
		E.db.unitframe.units.targettarget.rangeCheck = true
		E.db.unitframe.units.targettarget.debuffs.enable = false
		E.db.unitframe.units.targettarget.width = 50
		E.db.unitframe.units.targettarget.height = 34
		E.db.unitframe.units.targettarget.power.enable = false
		E.db.unitframe.units.targettarget.name.position = "CENTER"
		E.db.unitframe.units.targettarget.name.text_format = "[name:veryshort]"
		E.db.unitframe.units.targettarget.name.xOffset = 1
		E.db.unitframe.units.targettarget.name.yOffset = 0
		E.db.unitframe.units.targettarget.healPrediction = false
		E.db.unitframe.units.targettarget.customTexts = {}
	--Focus
		E.db.unitframe.units.focus.rangeCheck = false
		E.db.unitframe.units.focus.width = 50
		E.db.unitframe.units.focus.height = 30
		E.db.unitframe.units.focus.power.enable = false
		E.db.unitframe.units.focus.threatStyle = "NONE"
		E.db.unitframe.units.focus.name.position = "CENTER"
		E.db.unitframe.units.focus.name.text_format = "[name:veryshort]"
		E.db.unitframe.units.focus.name.yOffset = 0
		E.db.unitframe.units.focus.name.xOffset = 1
		E.db.unitframe.units.focus.debuffs.enable = false
		E.db.unitframe.units.focus.castbar.enable = false
		E.db.unitframe.units.focus.healPrediction = false
	--Pet
		E.db.unitframe.units.pet.width = 85
		E.db.unitframe.units.pet.height = 25
		E.db.unitframe.units.pet.threatStyle = "NONE"
		E.db.unitframe.units.pet.healPrediction = false
		E.db.unitframe.units.pet.power.enable = false
		E.db.unitframe.units.pet.name.text_format = ""
		E.db.unitframe.units.pet.buffIndicator.enable = false
		E.db.unitframe.units.pet.castbar.enable = false
	--Boss
		E.db.unitframe.units.boss.enable = true
		E.db.unitframe.units.boss.width = 175
		E.db.unitframe.units.boss.height = 35
		E.db.unitframe.units.boss.health.text_format = "[health:percent]"
		E.db.unitframe.units.boss.health.position = "TOPRIGHT"
		E.db.unitframe.units.boss.power.enable = true
		E.db.unitframe.units.boss.power.position = "BOTTOM"
		E.db.unitframe.units.boss.power.yOffset = -8
		E.db.unitframe.units.boss.power.text_format = ""
		E.db.unitframe.units.boss.power.height = 4
		E.db.unitframe.units.boss.power.width = "spaced"
		E.db.unitframe.units.boss.name.text_format = "[name:abbrev]  [smartlevel]"
		E.db.unitframe.units.boss.name.position = "TOPLEFT"
		E.db.unitframe.units.boss.buffs.enable = false
		E.db.unitframe.units.boss.debuffs.enable = true
		E.db.unitframe.units.boss.debuffs.sizeOverride = 25
		E.db.unitframe.units.boss.debuffs.anchorPoint = "LEFT"
		E.db.unitframe.units.boss.debuffs.xOffset = -5
		E.db.unitframe.units.boss.debuffs.yOffset = 0
		E.db.unitframe.units.boss.debuffs.perrow = 4
		E.db.unitframe.units.boss.debuffs.numrows = 1
		E.db.unitframe.units.boss.debuffs.fontSize = 8
		E.db.unitframe.units.boss.castbar.enable = true
		E.db.unitframe.units.boss.castbar.width = 175
		E.db.unitframe.units.boss.castbar.height = 10
		E.db.unitframe.units.boss.castbar.spark = false
		E.db.unitframe.units.boss.castbar.icon = false
		E.db.unitframe.units.boss.growthDirection = "UP"
		E.db.unitframe.units.boss.spacing = 16
	--Arena
		E.db.unitframe.units.arena.width = 225
		E.db.unitframe.units.arena.height = 40
		E.db.unitframe.units.arena.health.text_format = "[health:current]"
		E.db.unitframe.units.arena.power.text_format = "[powercolor][power:current]"
		E.db.unitframe.units.arena.name.text_format = "[namecolor][name:medium]"
		E.db.unitframe.units.arena.buffs.anchorPoint = "RIGHT"
		E.db.unitframe.units.arena.buffs.fontSize = 11
		E.db.unitframe.units.arena.buffs.sizeOverride = 18
		E.db.unitframe.units.arena.buffs.xOffset = 2
		E.db.unitframe.units.arena.buffs.yOffset = 10
		E.db.unitframe.units.arena.debuffs.fontSize = 11
		E.db.unitframe.units.arena.debuffs.sizeOverride = 18
		E.db.unitframe.units.arena.debuffs.xOffset = 2
		E.db.unitframe.units.arena.debuffs.yOffset = -10
		E.db.unitframe.units.arena.castbar.width = 225
		E.db.unitframe.units.arena.castbar.height = 10
		E.db.unitframe.units.arena.castbar.icon = false
		E.db.unitframe.units.arena.castbar.format = ""
		E.db.unitframe.units.arena.castbar.spark = false
	--Party
		E.db.unitframe.units.party.width = 55
		E.db.unitframe.units.party.height = 40
		E.db.unitframe.units.party.threatStyle = "NONE"
		E.db.unitframe.units.party.growthDirection = "RIGHT_DOWN"
		E.db.unitframe.units.party.horizontalSpacing = 2
		E.db.unitframe.units.party.verticalSpacing = 2
		E.db.unitframe.units.party.health.yOffset = -3
		E.db.unitframe.units.party.health.position = "CENTER"
		E.db.unitframe.units.party.health.text_format = "[health:deficit]"
		E.db.unitframe.units.party.power.enable = false
		E.db.unitframe.units.party.power.position = "TOPRIGHT"
		E.db.unitframe.units.party.power.height = 4
		E.db.unitframe.units.party.power.width = "inset"
		E.db.unitframe.units.party.name.position = "TOP"
		E.db.unitframe.units.party.name.text_format = "[name:veryshort]"
		E.db.unitframe.units.party.name.yOffset = -4
		E.db.unitframe.units.party.debuffs.enable = false
		E.db.unitframe.units.party.GPSArrow.enable = false
		E.db.unitframe.units.party.buffIndicator.enable = false
		E.db.unitframe.units.party.roleIcon.enable = false
		E.db.unitframe.units.party.roleIcon.position = "TOPLEFT"
		E.db.unitframe.units.party.debuffs.enable = false
		E.db.unitframe.units.party.debuffs.perrow = 1
		E.db.unitframe.units.party.debuffs.numrows = 3
		E.db.unitframe.units.party.debuffs.sizeOverride = 33
		E.db.unitframe.units.party.debuffs.yOffset = -5
		E.db.unitframe.units.party.debuffs.anchorPoint = "BOTTOM"
		E.db.unitframe.units.party.debuffs.onlyDispellable = false
		E.db.unitframe.units.party.debuffs.fontSize = 8
		E.db.unitframe.units.party.buffs.enable = false
		E.db.unitframe.units.party.buffs.perrow = 2
		E.db.unitframe.units.party.buffs.numrows = 1
		E.db.unitframe.units.party.buffs.sizeOverride = 20
		E.db.unitframe.units.party.buffs.xOffset = -47
		E.db.unitframe.units.party.buffs.yOffset = 0
		E.db.unitframe.units.party.buffs.anchorPoint = "RIGHT"
		E.db.unitframe.units.party.rdebuffs.enable = true
		E.db.unitframe.units.party.visibility = "[@raid6,exists][nogroup] hide;show"
		E.db.unitframe.units.party.colorOverride = "USE_DEFAULT"
	--Raid
		E.db.unitframe.units.raid.width = 55
		E.db.unitframe.units.raid.height = 35
		E.db.unitframe.units.raid.threatStyle = "NONE"
		E.db.unitframe.units.raid.growthDirection = "RIGHT_UP"
		E.db.unitframe.units.raid.visibility = "[@raid6,noexists] hide;show"
		E.db.unitframe.units.raid.horizontalSpacing = 2
		E.db.unitframe.units.raid.verticalSpacing = 2
		E.db.unitframe.units.raid.rdebuffs.enable = true
		E.db.unitframe.units.raid.health.text_format = ""
		E.db.unitframe.units.raid.power.enable = false
		E.db.unitframe.units.raid.name.position = "CENTER"
		E.db.unitframe.units.raid.name.text_format = "[name:veryshort]"
		E.db.unitframe.units.raid.GPSArrow.enable = false
		E.db.unitframe.units.raid.roleIcon.enable = false
		E.db.unitframe.units.raid.numGroups = 8
		E.db.unitframe.units.raid40.enable = false
		E.db.unitframe.units.raid40.width = 55
		E.db.unitframe.units.raid40.height = 30
		E.db.unitframe.units.tank.enable = false
		E.db.unitframe.units.assist.enable = false
		E.db.unitframe.units.raid.colorOverride = "USE_DEFAULT"
		E.db.unitframe.units.raid.buffIndicator.enable = false
	--Other
		E.db.unitframe.units.tank.enable = false
		E.db.unitframe.units.assist.enable = false
	-- Bags
		E.db.bags.bagSize = 34
		E.db.bags.bankSize = 34
		E.db.bags.bagWidth = 473
		E.db.bags.bankWidth = 473
		E.db.bags.alignToChat = false
		E.db.bags.sortInverted = false
		E.db.bags.moneyFormat = "BLIZZARD"
		E.db.bags.currencyFormat = "ICON"
		E.db.bags.countFontSize = 8
		E.db.bags.countFont = "Semplice C"
		E.db.bags.countFontOutline = "MONOCHROMEOUTLINE"
		E.db.bags.itemLevel = false
		E.db.bags.itemLevelFont = "Semplice C"
		E.db.bags.itemLevelFontSize = 8
		E.db.bags.itemLevelOutline = "MONOCHROMEOUTLINE"
	-- Nameplate
		E.db.nameplates.font = "Semplice C"
		E.db.nameplates.fontSize = 8
		E.db.nameplates.fontOutline = "MONOCHROMEOUTLINE"
		E.db.nameplates.nonTargetTransparency = 0.4
		E.db.nameplates.statusbar = "tFlat"
		E.db.nameplates.units.HEALER.healthbar.enable = false
		E.db.nameplates.units.PLAYER.enable = false
		E.db.nameplates.units.ENEMY_NPC.debuffs.baseHeight = 15
		E.db.nameplates.classbar.enable = false
		E.db.nameplates.motionType = "OVERLAP"
	-- Auras
		E.db.auras.disableBlizzard = true
		E.db.auras.font = "Semplice C"
		E.db.auras.fontSize = 8
		E.db.auras.fontOutline = "MONOCHROMEOUTLINE"
		E.db.auras.buffs.wrapAfter = 12
		E.db.auras.buffs.maxWraps = 2
		E.db.auras.buffs.horizontalSpacing = 2
		E.db.auras.buffs.verticalSpacing = 16
		E.db.auras.buffs.size = 32
		E.db.auras.buffs.seperateOwn = 0
		E.db.auras.debuffs.horizontalSpacing = 3
		E.db.auras.debuffs.wrapAfter = 6
		E.db.auras.debuffs.seperateOwn = 0
		E.db.auras.debuffs.sortDir = "+"
		E.db.auras.debuffs.size = 32
	-- Chat
		E.db.chat.font = "Roboto-Black"
		E.db.chat.fontOutline = "OUTLINE"
		E.db.chat.emotionIcons = false
		E.db.chat.panelWidth = 450
		E.db.chat.separateSizes = false
		E.db.chat.panelHeight = 222
		E.db.chat.panelBackdrop = "HIDEBOTH"
		E.db.chat.panelTabBackdrop = false
		E.db.chat.tabFont = "Semplice C"
		E.db.chat.tabFontSize = 8
		E.db.chat.tabFontOutline = "MONOCHROMEOUTLINE"
		E.db.chat.lfgIcons = false
		E.db.chat.chatHistory = false
		E.db.chat.keywords = "%MYNAME%, ElvUI, TohrUI"
		E.db.chat.timeStampFormat = "NONE"
		E.db.chat.editBoxPosition = "ABOVE_CHAT"
		E.db.chat.fadeUndockedTabs = false
	-- Data Text
		E.db.datatexts.font = "Semplice C"
		E.db.datatexts.fontSize = 8
		E.db.datatexts.fontOutline = "MONOCHROMEOUTLINE"
		E.db.datatexts.minimapPanels = true
		E.db.datatexts.rightChatPanel = false
		E.db.datatexts.leftChatPanel = true
		E.db.datatexts.panels.LeftChatDataPanel.left = "Durability"
		E.db.datatexts.panels.LeftChatDataPanel.middle = "Garrison"
		E.db.datatexts.panels.LeftChatDataPanel.right = "System"
		E.db.datatexts.panels.RightChatDataPanel.left = ""
		E.db.datatexts.panels.RightChatDataPanel.middle = ""
		E.db.datatexts.panels.RightChatDataPanel.right = ""
		E.db.datatexts.panels.LeftMiniPanel = ""
		E.db.datatexts.panels.RightMiniPanel = "Time"
		E.db.datatexts.battleground = false
	-- Tooltip
		E.db.tooltip.cursorAnchor = false
		E.db.tooltip.targetInfo = true
		E.db.tooltip.playerTitles = false
		E.db.tooltip.inspectInfo = false
		E.db.tooltip.guildRanks = false
		E.db.tooltip.talentInfo = false
		E.db.tooltip.itemCount = "BOTH"
		E.db.tooltip.spellID = true
		E.db.tooltip.healthBar.height = 0
		E.db.tooltip.healthBar.font = "Roboto-Black"
		E.db.tooltip.healthBar.text = false
		E.db.tooltip.healthBar.fontSize = 12
		E.db.tooltip.textFontSize = 10
		E.db.tooltip.font = "Roboto-Black"
		E.db.tooltip.fontOutline = "OUTLINE"
		E.db.tooltip.smallTextFontSize = 10
		
	-- Cooldown
		E.db.cooldown.threshold = 2
		E.db.cooldown.expiringcolor = { r = 255/255, g = 54/255, b = 54/255 }
		E.db.cooldown.secondscolor = { r = 156/255, g = 255/255, b = 123/255 }
		E.db.cooldown.minutescolor = { r = 1, g = 1, b = 1 }
		E.db.cooldown.hourscolor = { r = 102/225, g = 255/225, b = 255/225 }
		E.db.cooldown.dayscolor = { r = 102/225, g = 102/225, b = 255/225 }
	-- Actionbars
		E.db.actionbar.font = "Semplice C"
		E.db.actionbar.movementModifier = "CTRL"
		E.db.actionbar.fontSize = 8
		E.db.actionbar.fontOutline = "MONOCHROMEOUTLINE"
		E.db.actionbar.hotkeytext = false
		E.db.actionbar.noRangeColor = {r = 204/255, g = 26/255, b = 26/255}
		E.db.actionbar.noPowerColor = {r = 128/255, g = 128/255, b = 255/255}
		E.db.actionbar.microbar.enabled = false
		E.db.actionbar.microbar.mouseover = true
		E.db.actionbar.bar1.mouseover = false
		E.db.actionbar.bar1.buttons = 12
		E.db.actionbar.bar1.buttonsPerRow = 12
		E.db.actionbar.bar1.buttonsize = 28
		E.db.actionbar.bar1.buttonspacing = 1
		E.db.actionbar.bar1.backdrop = false
		E.db.actionbar.bar2.enabled = true
		E.db.actionbar.bar2.mouseover = false
		E.db.actionbar.bar2.buttons = 12
		E.db.actionbar.bar2.buttonsPerRow = 12
		E.db.actionbar.bar2.buttonsize = 28
		E.db.actionbar.bar2.buttonspacing = 1
		E.db.actionbar.bar2.backdrop = false
		E.db.actionbar.bar3.mouseover = true
		E.db.actionbar.bar3.buttons = 12
		E.db.actionbar.bar3.buttonsPerRow = 12
		E.db.actionbar.bar3.buttonsize = 28
		E.db.actionbar.bar3.buttonspacing = 1
		E.db.actionbar.bar3.backdrop = false
		E.db.actionbar.bar4.enabled = false
		E.db.actionbar.bar4.mouseover = false
		E.db.actionbar.bar4.buttons = 12
		E.db.actionbar.bar4.point = "BOTTOMLEFT"
		E.db.actionbar.bar4.buttonsPerRow = 12
		E.db.actionbar.bar4.backdrop = false
		E.db.actionbar.bar4.buttonsize = 26
		E.db.actionbar.bar4.buttonspacing = 2
		E.db.actionbar.bar5.mouseover = false
		E.db.actionbar.bar5.buttons = 6
		E.db.actionbar.bar5.buttonsPerRow = 12
		E.db.actionbar.bar5.buttonsize = 33
		E.db.actionbar.bar5.buttonspacing = 1
		E.db.actionbar.bar5.backdropspacing = 1
		E.db.actionbar.bar5.heightmultiplier = 1
		E.db.actionbar.bar5.widthmultiplier = 1
		E.db.actionbar.bar6.enabled = false
		E.db.actionbar.barPet.mouseover = false
		E.db.actionbar.barPet.buttonsize = 25
		E.db.actionbar.barPet.buttonsPerRow = 10
		E.db.actionbar.barPet.buttonspacing = 1
		E.db.actionbar.barPet.backdrop = false
		E.db.actionbar.barPet.point = "TOPLEFT"
		E.db.actionbar.barPet.alpha = 0.65
		E.db.actionbar.stanceBar.mouseover = false
		E.db.actionbar.stanceBar.point = "BOTTOMLEFT"
		E.db.actionbar.stanceBar.buttonsize = 30
		E.db.actionbar.stanceBar.buttonspacing = 2
		E.db.actionbar.stanceBar.buttonsPerRow = 1
		E.db.actionbar.stanceBar.backdrop = false
	--DataBars
		E.db.databars.experience.enable = true
		E.db.databars.experience.width = 148
		E.db.databars.experience.height = 10
		E.db.databars.experience.orientation = "HORIZONTAL"
		E.db.databars.artifact.enable = true
		E.db.databars.artifact.width = 148
		E.db.databars.artifact.height = 10
		E.db.databars.artifact.orientation = "HORIZONTAL"
		E.db.databars.reputation.enable = true
		E.db.databars.reputation.width = 148
		E.db.databars.reputation.height = 10
		E.db.databars.reputation.orientation = "HORIZONTAL"
		E.db.databars.honor.enable = true
		E.db.databars.honor.width = 148
		E.db.databars.honor.height = 10
		E.db.databars.honor.orientation = "HORIZONTAL"
	end
	
	if not noDisplayMsg then
		E:UpdateAll(true)
	end
end

function E:SetupAddon(addon)
	if addon == 'Skada' then
		if IsAddOnLoaded('Skada') then
			E:Print(L["The Default profile for Skada has been modified."])
			InstallStepComplete.message = L["AddOn profiles installed"]
			InstallStepComplete:Show()
			SkadaDB['profiles']["Default"] = {
			["windows"] = {
				{
					["classicons"] = false,
					["barslocked"] = true,
					["background"] = {
						["color"] = {
							["a"] = 0,
							["r"] = 0.376470588235294,
							["g"] = 0.376470588235294,
							["b"] = 0.376470588235294,
						},
						["height"] = 144.000022978112,
						["texture"] = "None",
					},
					["wipemode"] = "Damage",
					["set"] = "total",
					["y"] = 33.0054321289063,
					["barfont"] = "Semplice C",
					["title"] = {
						["color"] = {
							["a"] = 1,
							["r"] = 0,
							["g"] = 0,
							["b"] = 0,
						},
						["font"] = "Roboto-Black",
						["fontsize"] = 12,
						["borderthickness"] = 0,
						["height"] = 17,
						["texture"] = "tFlat",
					},
					["barfontflags"] = "OUTLINEMONOCHROME",
					["point"] = "BOTTOMRIGHT",
					["barfontsize"] = 8,
					["mode"] = "Damage",
					["x"] = -32.9991455078125,
					["bartexture"] = "tFlat",
					["barwidth"] = 235.000403689875,
					["barbgcolor"] = {
						["a"] = 0,
						["b"] = 0.337254901960784,
						["g"] = 0.337254901960784,
						["r"] = 0.337254901960784,
					},
					["barcolor"] = {
						["a"] = 0.800000011920929,
						["r"] = 0.443137254901961,
						["g"] = 0.443137254901961,
						["b"] = 0.443137254901961,
					},
					["returnaftercombat"] = true,
					["enabletitle"] = false,
					["buttons"] = {
						["menu"] = false,
						["mode"] = false,
						["segment"] = false,
					},
					["modeincombat"] = "Damage",
				}, -- [1]
			},
			["icon"] = {
				["hide"] = true,
			},
			["showranks"] = false,
			["onlykeepbosses"] = true,
			["tooltippos"] = "topright",
			["reset"] = {
				["join"] = 2,
			},
		}
		else
			E:Print(L["The AddOn Skada is not enabled. Profile not created."])
		end
		
		if IsAddOnLoaded('xCT+') then
			InstallStepComplete:Show()
			xCTSavedDB['profiles']["TohrUI"] = {
			["general"] = {
				["font"] = "Expressway",
				["enabledFrame"] = false,
				["fontOutline"] = "2OUTLINE",
			},
			["class"] = {
				["font"] = "Expressway",
				["enabledFrame"] = false,
				["fontOutline"] = "2OUTLINE",
			},
			["frames"] = {
				["general"] = {
					["fontSize"] = 24,
					["megaDamage"] = true,
					["showRepChanges"] = false,
					["showBuffs"] = false,
					["showDispells"] = false,
					["fontOutline"] = "2OUTLINE",
					["showPartyKills"] = false,
					["showDebuffs"] = false,
					["Y"] = 252,
					["X"] = 3,
					["showHonorGains"] = false,
					["showInterrupts"] = false,
					["showLowManaHealth"] = false,
					["font"] = "Roboto-Black",
				},
				["power"] = {
					["font"] = "Semplice",
					["enabledFrame"] = false,
					["Y"] = -230,
					["X"] = 423,
				},
				["healing"] = {
					["enableRealmNames"] = false,
					["fontSize"] = 8,
					["showFriendlyHealers"] = false,
					["secondaryFrame"] = 4,
					["enabledFrame"] = false,
					["enableOverHeal"] = false,
					["insertText"] = "top",
					["Width"] = 207,
					["Y"] = -322,
					["font"] = "Semplice C",
					["Height"] = 270,
					["X"] = -240,
					["fontJustify"] = "RIGHT",
				},
				["outgoing"] = {
					["fontSize"] = 8,
					["enableDotDmg"] = false,
					["insertText"] = "top",
					["enableAutoAttack"] = false,
					["Width"] = 173,
					["fontJustify"] = "LEFT",
					["X"] = 216,
					["Height"] = 290,
					["iconsSize"] = 12,
					["Y"] = -370,
					["font"] = "Semplice C",
				},
				["critical"] = {
					["fontSize"] = 8,
					["secondaryFrame"] = 2,
					["insertText"] = "top",
					["critPrefix"] = "|cffff0000>> |r",
					["Width"] = 145,
					["Y"] = -372,
					["font"] = "Semplice C",
					["Height"] = 295,
					["critPostfix"] = "",
					["X"] = 303,
				},
				["procs"] = {
					["enabledFrame"] = false,
					["font"] = "Semplice",
				},
				["loot"] = {
					["enabledFrame"] = false,
					["font"] = "Semplice",
				},
				["class"] = {
					["fontColor"] = {
					},
					["font"] = "Semplice",
					["enabledFrame"] = false,
				},
				["damage"] = {
					["fontSize"] = 8,
					["X"] = -233,
					["Width"] = 207,
					["fontJustify"] = "RIGHT",
					["font"] = "Semplice C",
					["Height"] = 270,
					["Y"] = -356,
				},
			},
			["outgoing"] = {
				["Y"] = 47,
				["fontSize"] = 12,
				["fontOutline"] = "2OUTLINE",
				["Height"] = 196,
				["font"] = "Expressway",
				["X"] = 209,
				["Width"] = 128,
			},
			["loot"] = {
				["font"] = "Expressway",
				["fontOutline"] = "2OUTLINE",
				["enabledFrame"] = false,
			},
			["damage"] = {
				["Y"] = -124,
				["X"] = -208,
				["fontOutline"] = "2OUTLINE",
				["font"] = "Expressway",
				["fontSize"] = 12,
			},
			["power"] = {
				["font"] = "Expressway",
				["enabledFrame"] = false,
				["fontOutline"] = "2OUTLINE",
			},
			["blizzardFCT"] = {
				["CombatThreatChanges"] = true,
				["CombatDamage"] = true,
			},
			["showStartupText"] = false,
			["megaDamage"] = {
				["decimalPoint"] = false,
			},
			["healing"] = {
				["enableRealmNames"] = false,
				["fontSize"] = 12,
				["Width"] = 128,
				["showFriendlyHealers"] = false,
				["font"] = "Expressway",
				["fontOutline"] = "2OUTLINE",
				["Height"] = 196,
				["Y"] = 47,
				["X"] = -208,
			},
			["critical"] = {
				["Y"] = -124,
				["fontSize"] = 12,
				["fontOutline"] = "2OUTLINE",
				["Height"] = 144,
				["font"] = "Expressway",
				["X"] = 209,
				["Width"] = 128,
			},
			["procs"] = {
				["font"] = "Expressway",
				["enabledFrame"] = false,
				["fontOutline"] = "2OUTLINE",
			},
			["spellFilter"] = {
				["listSpells"] = {
					["159238"] = true,
					["157607"] = true,
					["2823"] = true,
				},
				["filterOutgoingDamageValue"] = 1,
				["filterOutgoingHealingValue"] = 1,
			},
			["dbVersion"] = "4.1.7",
			["frameSettings"] = {
				["clearLeavingCombat"] = true,
				["frameStrata"] = "3LOW",
			},
		}
		end
		
		if IsAddOnLoaded('BigWigs') then
			E:Print(L["The Default profile for BigWigs has been modified."])
			InstallStepComplete.message = L["AddOn profiles installed"]
			InstallStepComplete:Show()
			BigWigs3DB = {["namespaces"] = {
				["BigWigs_Plugins_Victory"] = {
				},
				["BigWigs_Bosses_Hellfire Assault"] = {
					["profiles"] = {
						["Default"] = {
							[180184] = 0,
							["adds"] = 0,
						},
					},
				},
				["BigWigs_Plugins_Alt Power"] = {
					["profiles"] = {
						["Default"] = {
							["posx"] = 1193.95591919313,
							["fontSize"] = 11.999999726451,
							["disabled"] = true,
							["posy"] = 289.422569014691,
							["fontOutline"] = "",
							["font"] = "RobotoCondensed-Bold",
						},
					},
				},
				["BigWigs_Plugins_BossBlock"] = {
				},
				["BigWigs_Bosses_Archimonde"] = {
					["profiles"] = {
						["Default"] = {
							[183817] = 0,
							[183864] = 0,
							["markofthelegion_self"] = 65699,
							[187050] = 195,
							[190727] = 0,
							[185014] = 0,
							[183865] = 0,
							[-11603] = 0,
							[183963] = 0,
							[-11607] = 0,
							[185590] = 0,
						},
					},
				},
				["BigWigs_Plugins_Sounds"] = {
				},
				["BigWigs_Plugins_Statistics"] = {
				},
				["BigWigs_Plugins_Colors"] = {
				},
				["BigWigs_Plugins_Raid Icons"] = {
				},
				["BigWigs_Plugins_Bars"] = {
					["profiles"] = {
						["Default"] = {
							["outline"] = "OUTLINE",
							["fontSize"] = 8,
							["BigWigsAnchor_width"] = 191.000091552734,
							["BigWigsAnchor_y"] = 196.976675776614,
							["emphasizeGrowup"] = true,
							["BigWigsAnchor_x"] = 379.022448413907,
							["monochrome"] = true,
							["icon"] = false,
							["texture"] = "tFlat",
							["barStyle"] = "ElvUI",
							["BigWigsEmphasizeAnchor_width"] = 201.000198364258,
							["BigWigsEmphasizeAnchor_x"] = 834.845940354171,
							["font"] = "Semplice C",
							["BigWigsEmphasizeAnchor_y"] = 333.310771959805,
							["emphasizeScale"] = 1,
						},
					},
				},
				["BigWigs_Bosses_Fel Lord Zakuun"] = {
					["profiles"] = {
						["Default"] = {
							[179407] = 0,
							[181508] = 131,
						},
					},
				},
				["BigWigs_Plugins_Super Emphasize"] = {
					["profiles"] = {
						["Default"] = {
							["outline"] = "OUTLINE",
							["fontSize"] = 30,
							["monochrome"] = false,
							["font"] = "Roboto-Black",
						},
					},
				},
				["LibDualSpec-1.0"] = {
				},
				["BigWigs_Bosses_Hellfire Citadel Trash"] = {
					["profiles"] = {
						["Default"] = {
							[189464] = 0,
							[189491] = 0,
							[189550] = 0,
							[189470] = 0,
							[189538] = 0,
							[190043] = 0,
							[189512] = 0,
							[189504] = 0,
						},
					},
				},
				["BigWigs_Plugins_Respawn"] = {
				},
				["BigWigs_Plugins_Messages"] = {
					["profiles"] = {
						["Default"] = {
							["outline"] = "OUTLINE",
							["BWEmphasizeMessageAnchor_x"] = 609.422280381787,
							["BWEmphasizeCountdownMessageAnchor_x"] = 732.445069819041,
							["chat"] = false,
							["BWEmphasizeMessageAnchor_y"] = 535.466375813212,
							["BWMessageAnchor_y"] = 535.466506021548,
							["sink20OutputSink"] = "BigWigsEmphasized",
							["BWMessageAnchor_x"] = 609.421716145662,
							["BWEmphasizeCountdownMessageAnchor_y"] = 393.243889730493,
							["font"] = "Roboto-Black",
							["fontSize"] = 20,
							["monochrome"] = true,
						},
					},
				},
				["BigWigs_Bosses_Xhul'horac"] = {
					["profiles"] = {
						["Default"] = {
							[190224] = 0,
							[186448] = 0,
							[186135] = 0,
							[186407] = 65763,
							[190223] = 0,
							[186134] = 0,
							[186063] = 0,
							[186785] = 0,
							[186073] = 0,
						},
					},
				},
				["BigWigs_Plugins_Proximity"] = {
					["profiles"] = {
						["Default"] = {
							["soundDelay"] = 10,
							["fontSize"] = 20.000000273549,
							["disabled"] = true,
							["posx"] = 354.844387932617,
							["width"] = 100.000027628445,
							["objects"] = {
								["title"] = false,
								["close"] = false,
								["ability"] = false,
								["tooltip"] = false,
								["background"] = false,
							},
							["posy"] = 524.799535277143,
							["lock"] = true,
							["height"] = 95.9998665081086,
							["font"] = "RobotoCondensed-Bold",
						},
					},
				},
				["BigWigs_Bosses_Mannoroth"] = {
					["profiles"] = {
						["Default"] = {
							[186362] = 195,
							[181275] = 66211,
						},
					},
				},
			},
		}
		else
			E:Print(L["The AddOn BigWigs is not enabled. Profile not created."])
		end		
	end
end

local function InstallComplete()
	E.private.install_complete = E.version
	
	ReloadUI()
end
		
local function ResetAll()
	AddOnsBtn:Hide()
	AddOnsBtn:SetScript('OnClick', nil)
	AddOnsBtn:SetText('')
	CVarsBtn:Hide()
	CVarsBtn:SetScript('OnClick', nil)
	CVarsBtn:SetText('')
	SetupChatBtn:Hide()
	SetupChatBtn:SetScript('OnClick', nil)
	SetupChatBtn:SetText('')
	InstallBtn:Hide()
	InstallBtn:SetScript('OnClick', nil)
	InstallBtn:SetText('')
	FinishBtn:Hide()
	FinishBtn:SetScript('OnClick', nil)
	FinishBtn:SetText('')
	MoveBtn:Hide()
	MoveBtn:SetScript('OnClick', nil)
	MoveBtn:SetText('')
	ElvUIInstallFrame:Size(340, 260)
end

local function SetPage(PageNum)
	CURRENT_PAGE = PageNum
	ResetAll()
	
	local f = ElvUIInstallFrame
		
	if PageNum == 1 then
		f.InstallBtn:Show()
		f.FinishBtn:Show()	
	end	

	if PageNum == 1 then
		InstallBtn:Show()
		InstallBtn:SetScript('OnClick', function() E:SetupTheme('TohrUI') end)
		InstallBtn:SetText(L['|cffFF4D4DInstall'])	
		AddOnsBtn:Show()
		AddOnsBtn:SetScript("OnClick", function() E:SetupAddon('Skada') end)
		AddOnsBtn:SetText(L["|cff99E6FFAddOns"])
		CVarsBtn:Show()
		CVarsBtn:SetScript("OnClick", SetupCVars)
		CVarsBtn:SetText(L["|cffFF7D0ACVar"])	
		SetupChatBtn:Show()
		SetupChatBtn:SetScript("OnClick", SetupChat)
		SetupChatBtn:SetText(L["|cffBB33FFChat"])
		FinishBtn:Show()
		FinishBtn:SetScript("OnClick", InstallComplete)
		FinishBtn:SetText(L["|cff66FF66Finished!"])
		MoveBtn:Show()
		MoveBtn:SetScript("OnClick", function() E:ToggleConfigMode() end)
		MoveBtn:SetText(L['|cffFFFFFFU'])
	end
end

local function NextPage()	
	if CURRENT_PAGE ~= MAX_PAGE then
		CURRENT_PAGE = CURRENT_PAGE + 1
		SetPage(CURRENT_PAGE)
	end
end

local function PreviousPage()
	if CURRENT_PAGE ~= 1 then
		CURRENT_PAGE = CURRENT_PAGE - 1
		SetPage(CURRENT_PAGE)
	end
end

--Install UI
function E:Install()	
	if not InstallStepComplete then
		local imsg = CreateFrame("Frame", "InstallStepComplete", E.UIParent)
		imsg:Size(206, 150)
		imsg:Point("TOP", 0, -190)
		imsg:Hide()
		imsg:SetScript('OnShow', function(self)
			if self.message then 
				self.text:SetText(self.message)
				UIFrameFadeOut(self, 3.5, 1, 0)
				E:Delay(4, function() self:Hide() end)	
				self.message = nil

				if imsg.firstShow == false then			
					imsg.firstShow = true
				end
			else
				self:Hide()
			end
		end)

		imsg.firstShow = false

		imsg.bg = imsg:CreateTexture(nil, 'BACKGROUND')
		imsg.bg:SetTexture([[Interface\LevelUp\LevelUpTex]])
		imsg.bg:SetPoint('BOTTOM')
		imsg.bg:Size(206, 150)
		imsg.bg:SetTexCoord(0.00195313, 0.63867188, 0.03710938, 0.23828125)
		imsg.bg:SetVertexColor(1, 1, 1, 0.6)


		imsg.lineBottom = imsg:CreateTexture(nil, 'BACKGROUND')
		imsg.lineBottom:SetDrawLayer('BACKGROUND', 2)
		imsg.lineBottom:SetTexture([[Interface\LevelUp\LevelUpTex]])
		imsg.lineBottom:SetPoint("BOTTOM")
		imsg.lineBottom:Size(206, 150)
		imsg.lineBottom:SetTexCoord(0.00195313, 0.81835938, 0.01953125, 0.03320313)

		imsg.text = imsg:CreateFontString(nil, 'ARTWORK', 'GameFont_Gigantic')
		imsg.text:Point("BOTTOM", 0, 12)
		imsg.text:SetTextColor(1, 0.82, 0)
		imsg.text:SetJustifyH("CENTER")
		
	end

	--Create Frame
	if not ElvUIInstallFrame then
		local f = CreateFrame("Button", "ElvUIInstallFrame", E.UIParent)
		f.SetPage = SetPage
		f:Size(206, 150)
		f:SetTemplate("Transparent")
		f:SetPoint("CENTER")
		f:SetFrameStrata('LOW')		
		
		f.AddOns = CreateFrame("Button", "AddOnsBtn", f, "UIPanelButtonTemplate")
		f.AddOns:StripTextures()
		f.AddOns:Size(60, 30)
		f.AddOns:Point("BOTTOM", 0, 45)
		f.AddOns:SetText("")
		E.Skins:HandleButton(f.AddOns, true)
		
		f.CVars = CreateFrame("Button", "CVarsBtn", f, "UIPanelButtonTemplate")
		f.CVars:StripTextures()
		f.CVars:Size(55, 30)
		f.CVars:Point("BOTTOMRIGHT", -80, 45)
		f.CVars:SetText("")
		E.Skins:HandleButton(f.CVars, true)
		
		f.SetupChat = CreateFrame("Button", "SetupChatBtn", f, "UIPanelButtonTemplate")
		f.SetupChat:StripTextures()
		f.SetupChat:Size(55, 30)
		f.SetupChat:Point("BOTTOMLEFT", 80, 45)
		f.SetupChat:SetText("")
		E.Skins:HandleButton(f.SetupChat, true)
		
		f.InstallBtn = CreateFrame("Button", "InstallBtn", f, "UIPanelButtonTemplate")
		f.InstallBtn:StripTextures()
		f.InstallBtn:SetAlpha(1)
		f.InstallBtn:SetFrameStrata('MEDIUM')
		f.InstallBtn:Size(180, 40)
		f.InstallBtn:Point("BOTTOM", 0, 80)
		f.InstallBtn:SetText("")
		E.Skins:HandleButton(f.InstallBtn, true)
		
		f.FinishBtn = CreateFrame("Button", "FinishBtn", f, "UIPanelButtonTemplate")
		f.FinishBtn:StripTextures()
		f.FinishBtn:SetAlpha(1)
		f.FinishBtn:Size(180, 30)
		f.FinishBtn:Point("BOTTOM", 0, 10)
		f.FinishBtn:SetText("")
		E.Skins:HandleButton(f.FinishBtn, true)
		
		f.ResetBtn = CreateFrame("Button", "ResetBtn", f, "UIPanelButtonTemplate")
		f.ResetBtn:StripTextures()
		f.ResetBtn:SetAlpha(0)
		f.ResetBtn:Size(125, 30)
		f.ResetBtn:Point("BOTTOM", 0, -31)
		f.ResetBtn:SetText("")
		E.Skins:HandleButton(f.ResetBtn, true)
		
		f.MoveBtn = CreateFrame("Button", "MoveBtn", f, "UIPanelButtonTemplate")
		f.MoveBtn:StripTextures()
		f.MoveBtn:SetFrameStrata('MEDIUM')
		f.MoveBtn:Size(16, 16)
		f.MoveBtn:Point("BOTTOMLEFT", f, "BOTTOMLEFT", 2, 2)
		f.MoveBtn:SetText("")
		f.MoveBtn:SetAlpha(1)
		E.Skins:HandleButton(f.MoveBtn, true)
		
		local close = CreateFrame("Button", "InstallCloseButton", f, "UIPanelCloseButton")
		close:SetAlpha(1)
		close:SetPoint("BOTTOMRIGHT", f, "BOTTOMRIGHT", 6, -6)
		close:SetScript("OnClick", function()
			f:Hide()
		end)
		E.Skins:HandleCloseButton(close)
		
		f.Logo = f:CreateTexture('Logo', 'OVERLAY')
		f.Logo:SetTexture('Interface\\AddOns\\ElvUI_TohrUI\\media\\textures\\TohrUI.tga')
		f.Logo:Point('TOP', 0, 0)
		
		--f.ResetBtn = f:CreateTexture('ResetButton', 'OVERLAY')
		--f.ResetBtn:SetTexture('Interface\\AddOns\\ElvUI_TohrUI\\media\\textures\\reset.tga')
		--f.ResetBtn:Point("BOTTOM", "ElvUIInstallFrame", 0, -50)
		
		--f.Left = f:CreateTexture('arrowLeftImage', 'OVERLAY')
		--f.Left:SetTexture('Interface\\AddOns\\ElvUI_TohrUI\\media\\textures\\arrowLeft.tga')
		--f.Left:Point('LEFT', "ElvUIInstallFrame", -60, 0)
		
		--f.Right = f:CreateTexture('arrowRightImage', 'OVERLAY')
		--f.Right:SetTexture('Interface\\AddOns\\ElvUI_TohrUI\\media\\textures\\arrowRight.tga')
		--f.Right:Point('RIGHT', "ElvUIInstallFrame", 60, 0)
		
	end
	
	ElvUIInstallFrame:Show()
	NextPage()
end