local mod = LibStub("AceAddon-3.0"):NewAddon("MapFader", "AceEvent-3.0", "AceTimer-3.0")
 
local OTFContainer = CreateFrame("Frame", "OTFContainer")
 
function mod:OnInitialize(profile)
   
end
 
function mod:OnEnable()
    Minimap:SetAlpha(0)
    mod:NewFrame(Minimap)
   
    self:RegisterEvent("PLAYER_ENTERING_WORLD")
    OTFContainer:RegisterEvent("PLAYER_ENTERING_WORLD")
    OTFContainer:RegisterUnitEvent("UNIT_AURA", "player")
    OTFContainer:SetScript("OnEvent", function()
       if OrderHallCommandBar then
           OrderHallCommandBar:Hide()
       end
    end)
end
 
function mod:PLAYER_ENTERING_WORLD()
    self:moveObjectiveTracker()
end
 
function mod:moveObjectiveTracker()
    OTFContainer:SetScale(0.8)
    OTFContainer:ClearAllPoints()
    OTFContainer:SetPoint("TOPLEFT", UIParent, "TOPLEFT", 0, -100)
    OTFContainer:SetWidth(265)
    OTFContainer:SetHeight(1000)
    ObjectiveTrackerFrame:SetParent(OTFContainer)
    ObjectiveTrackerFrame:SetClampedToScreen(false)
    ObjectiveTrackerFrame:ClearAllPoints()
    ObjectiveTrackerFrame:SetPoint("TOPLEFT", 30, -10)
    local cap = ObjectiveTrackerFrame.ClearAllPoints
    local sp = ObjectiveTrackerFrame.SetPoint
    hooksecurefunc(ObjectiveTrackerFrame, "SetPoint", function(self)
        cap(self)
        sp(self, "TOPLEFT", 30, -10)
        self:SetHeight(980)
    end)
    ObjectiveTracker_MinimizeButton_OnClick()
end
 
do
    local animGroup = Minimap:CreateAnimationGroup()
    local anim = animGroup:CreateAnimation("Alpha")
    animGroup:SetScript("OnFinished", function()
        -- Minimap or Minimap icons including nil checks to compensate for other addons
        local focus = GetMouseFocus()
        if focus and ((focus:GetName() == "Minimap") or (focus:GetParent() and focus:GetParent():GetName() and focus:GetParent():GetName():find("Mini[Mm]ap"))) then
            Minimap:SetAlpha(1)
        else
            Minimap:SetAlpha(0)
        end
    end)
    anim:SetOrder(1)
    anim:SetDuration(0.3)
 
    local fadeStop -- Use a variable to prevent fadeout/in when moving the mouse around minimap/icons
 
    local OnEnter = function()
        if fadeStop then return end
 
        local delayed = anim:IsDelaying()
        animGroup:Stop()
        if not delayed then
            Minimap:SetAlpha(0)
            anim:SetStartDelay(0)
            anim:SetToAlpha(1)
            animGroup:Play()
        end
    end
    local OnLeave = function()
        local focus = GetMouseFocus() -- Minimap or Minimap icons including nil checks to compensate for other addons
        if focus and ((focus:GetName() == "Minimap") or (focus:GetParent() and focus:GetParent():GetName() and focus:GetParent():GetName():find("Mini[Mm]ap"))) then
            fadeStop = true
            return
        end
        fadeStop = nil
 
        animGroup:Stop()
        Minimap:SetAlpha(1)
        anim:SetStartDelay(0.5)
        anim:SetToAlpha(0)
        animGroup:Play()
    end
 
    function mod:NewFrame(f)
        f:HookScript("OnEnter", OnEnter)
        f:HookScript("OnLeave", OnLeave)
    end
end